 /**************************************************************************\
(                                                                            )
 ) Klassisches Fließkomma-Mandelbrötchen.                   2015-08-20/Yeti (
(                                                                            )
 ) Basierend auf dem Code für ein monochromes Bild im PPM(-P6)-Format von   (
(  http://rosettacode.org/wiki/Mandelbrot_set#C plus einige unspektakuläre   )
 ) Änderungen zur Anpassung an den Propeller und das PGM(-P3)-Format.       (
(                                                                            )
 \**************************************************************************/

#include <propeller.h>
// fixpoint arithmetic mandelbrot program
// using 16 bits: viiiffffffffffff
//                ||  |_ broken part
//                ||____ integer part
//                |_____ sign bit
//
// so fixedpoint(x) = x * 4096
//                  = x << 12
// and fixedpoint(x*y) = (x*y)>>12

#include <stdio.h>
#include <stdint.h>

#define XMIN (-8601)
#define XMAX ( 2867)
#define YMIN (-4915)
#define YMAX ( 4915)

#define MAXI (32)

#define DX   ((XMAX-XMIN)/79)
#define DY   ((YMAX-YMIN)/24)

int main() {
  int32_t cx,cy,x,y,x2,y2;
  uint32_t iter;
  
  for( cy=YMIN; cy<=YMAX; cy+=DY ) {
    for( cx=XMIN; cx<=XMAX; cx+=DX ) {
      x = y = x2 = y2 = 0;
      for( iter=0; iter<MAXI && x2+y2<=16384; iter++ ) {
        y = ((x*y)>>11)+cy;
        x = x2-y2+cx;
        x2 = (x*x)>>12;
        y2 = (y*y)>>12;
      }
      putchar(32+iter);
    }
    putchar(13);
//  putchar(10); // may or may not be neccessary.
  }
  cogstop(0);
}
